package cc.smtweb.system.bpm.web.engine.model.listcard.single;

import cc.smtweb.framework.core.common.R;
import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.system.bpm.web.design.form.define.PageDataset;
import cc.smtweb.system.bpm.web.engine.dynPage.AbstractDynPageHandler;
import cc.smtweb.system.bpm.web.engine.dynPage.DynPageHelper;
import cc.smtweb.system.bpm.web.engine.dynPage.DynPageListHandler;
import cc.smtweb.system.bpm.web.engine.dynPage.DynRetBean;

/**
 * Created by Akmm at 2022-08-16 15:43
 */
public class LCSingleLoadHandler extends AbstractDynPageHandler {

    //新增卡片操作，初始化定义的数据集
    public R add() {
        //返回的数据，以dataset.name为key，查出的结果（bean或list）为value
        PageDataset cardDataset = LCSingleHelper.findCardDataset(datasets);
        SwMap data;
        //懒加载，给个空对象
        if (cardDataset.lazy) {
            data = new SwMap();
        } else {
            data = DynPageHelper.createBean(cardDataset);
        }
        afterAddBean(cardDataset, data);

        return R.success(LCSingleHelper.buildRetData(cardDataset.name, data));
    }

    //新增初始化 - bean
    protected void afterAddBean(PageDataset dataset, SwMap bean) {
    }

    //加载之后
    protected void afterLoadBean(PageDataset dataset, SwMap bean) {
    }

    public R load() {
        //过滤条件
        SwMap filter = params.readMap("filter");
        //对应的数据集定义
        PageDataset cardDataset = LCSingleHelper.findCardDataset(datasets);

        SwMap data = provider.loadData(filter, cardDataset);
        afterLoadBean(cardDataset, data);

        return R.success(LCSingleHelper.buildRetData(cardDataset.name, data));
    }

    protected DynPageListHandler getListWorker(SwMap filter, PageDataset pageDataSet) {
        DynPageListHandler listHandler = new DynPageListHandler(form.getId(), filter, pageDataSet);
        listHandler.init(params, us);
        return listHandler;
    }

    /**
     * 列表数据
     * @return
     */
    public R list() {
        //过滤条件
        SwMap filter = params.readMap("filter");
        //对应的数据集定义
        PageDataset pageDataSet = LCSingleHelper.findListDataset(datasets);

        DynRetBean bean = DynRetBean.createList(getListWorker(filter, pageDataSet).buildListData());

        return R.success(bean);
    }

    /**
     * 计算分页数据
     *
     * @return
     */
    public R getTotal() {
        //数据集
        PageDataset pageDataSet = LCSingleHelper.findListDataset(datasets);
        //过滤条件
        SwMap filter = params.readMap("filter");

        return getListWorker(filter, pageDataSet).getTotal();
    }
}
